<?php
require ('../class/template/Template.class.php');

# Konfigurationsmöglichkeiten
$size = (array_key_exists('size',$_REQUEST) && in_array($_REQUEST['size'],array('small','big'))) ? $_REQUEST['size'] : 'small';

$fields = (array_key_exists('fields',$_REQUEST)) ? $_REQUEST['fields'] : '0,1,5';
$fields = explode(',',$fields);

$css = (array_key_exists('css',$_REQUEST)) ? $_REQUEST['css'] : '';

$embed = (array_key_exists('embed',$_REQUEST)) ? true : false;

$datum = (array_key_exists('date',$_REQUEST) && (DateTime::createFromFormat('Y-m-d', $_REQUEST['date']))) ? $_REQUEST['date'] : date('Y-m-d');

$current = (array_key_exists('current',$_REQUEST) && $_REQUEST['current'] == 'true') ? 'last' : 'next'; 

# Daten holen
$url = "https://www.kirchenjahr-evangelisch.de/service.php?o=lcf&f=gwd&r=json&date=".$datum;
$curl = curl_init($url);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
$content = curl_exec ($curl);
$curl_info = curl_getinfo ($curl);

if($curl_info['http_code'] == '200' && $content != '') {
	$data = json_decode($content);
	$song = '';

	$arr_fieldsIndex = array('WeeklyQuote', 'WeeklyPsalm','EntryPsalm','OldTestament','Epistel','Perikope'.$data->next->perikope,'Evangelium', 'songs', 'WeeklyQuoteText');
	$arr_fieldsCaptions = array('Wochenspruch', 'Wochenpsalm', 'Eingangspsalm', 'AT-Lesung', 'Epistel', 'Predigttext', 'Evangelium', 'Wochenlied', 'Wochenspruch');
	$arr_fields = array();

	foreach ($fields as $field) {
		if (is_numeric($field) && ($field < 7)) $arr_fields[$arr_fieldsIndex[(int)$field]] = $arr_fieldsCaptions[(int)$field];

		if ($field == 7) {
		    $song = '';
		    foreach ($data->$current->{'songs'} as $id => $ong) {
		        if ($id > 0) $song .= '<br />oder<br />';
		        $song .= $ong->title;
		        if ('' != $ong->number) $song .= ' ('.$ong->number.')';
		    }
		}

		if ($field == 8) {
		    $litColorName = $data->$current->litColorName;
		}
		
		if ($field == 9) {		    
		    $weeklyQuoteText = $data->$current->litTextsWeeklyQuoteText;
		    unset($arr_fields[$arr_fieldsIndex[0]]);
		}
	}

	try {
		$output = new Template();
		if ($current == 'last') {
		    $data->next = $data->last;
		    $data->headline = 'Aktueller Feiertag';
		} else {
		    $data->headline = 'Nächster Feiertag';
		}
		$output->data = $data;
		$output->fields = $arr_fields;
		$output->css = $css;
		$output->song= $song;
		$output->litColorName = $litColorName;
		$output->weeklyQuoteText = $weeklyQuoteText;
		$output->embed = $embed;
		print $output->render('widget/'.$size.'.tpl.php');

	} catch(Exception $ex) {
		echo "Fehler!";
	}


} else {
	# Fehlermeldung:
	echo '<div>Kirchenjahr evangelisch ist derzeit nicht verfügbar.</div>';
}
?>